package com.jevon.service;

import com.jevon.model.ClassCourse;

import java.util.List;

/**
 * @author chen
 * @version 1.0
 * @date 2019/9/24 0024 11:44
 */
public interface ClassCourseService {

    int insertBatch(List<ClassCourse> classCourses);

    boolean insertSchoolClass(List<ClassCourse> classCourses);

    //通过 singleOrDouble , classId , week , courseNumber 获取某一天第几节课
    ClassCourse selectClassCourse(ClassCourse classCourse);

    int updateByPrimaryKey(ClassCourse record);

    //grade 获取该年段是单双周排课 boolean true 为双周
    boolean selectSingleOrDouble(ClassCourse classCourse);

    //获取每天课数
    int selectMaxCourseNumber(int schoolId , String team);

    //通过classID  单双周 获取该班课表
    List<ClassCourse> selectByClassIdAndSingleOrDouble(ClassCourse classCourse);

    //查询当前班某天是否已有某课
    int selectCourseByClassIdAndWeek(ClassCourse classCourse);

    //更新公共课以及选修课
    int updatePublicOreElective(ClassCourse classCourse);

    //查询未排课
    List<ClassCourse> selectNoCourse(int classId , String team);

    //查询改天 是否有某课
    List<ClassCourse> selectWeekCourse(int classId , int week , int singOrDouble , String courseName , String team);

    //查询不排课的课程
    List<ClassCourse> selectClassCourseByClass(ClassCourse classCourse);

    int deleteBySchoolIdAndTeam(int schoolId , String team);

    //撤回
    int recallClassCourse(ClassCourse classCourse);

    List<ClassCourse> copyClassCourse(int schoolId ,String team);


}
