package com.jevon.service;

import com.jevon.model.TeacherClass;

import java.util.List;

/**
 * @author chen
 * @version 1.0
 * @date 2019/9/29 0029 11:04
 */
public interface TeacherClassService {

    int insert(TeacherClass teacherClass);

    int insertBatch(List<TeacherClass> teacherClasses);

    List<TeacherClass> selectByCourseName(TeacherClass teacherClass);

    TeacherClass selectByTeacher(TeacherClass teacherClass);

    //通过学校 年段 班级  课程 获取对应授课老师
    TeacherClass selectByCourseAndClass(TeacherClass teacherClass);

    List<TeacherClass> selectBySchoolAndTeam(TeacherClass teacherClass);

    int deleteBySchoolAndTeam(TeacherClass teacherClass);

    TeacherClass selectById(int tClassId);

    int updateSchedule(int tClassId);

    //查询是否已排课
    int selectHasSchedule(int schoolId , String team);

    int recallTeacherClass(int tClassId);

    //查询该老师一周的课程，并计算平均每天最多课
    int selectTeacherDayClass(int schoolId , String team , String teacherName);

}
