package com.jevon.service.impl;

import com.jevon.mapper.AnalyseDetailMapper;
import com.jevon.model.AnalyseDetail;
import com.jevon.service.AnalyseDetailService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
 * @author chen
 * @version 1.0
 * @date 2019/10/18 0018 11:26
 */
@Service
public class AnalyseDetailServiceImpl implements AnalyseDetailService {

    @Autowired
    AnalyseDetailMapper analyseDetailMapper;

    @Override
    public int insertBatch(List<AnalyseDetail> list) {
        int i = 0 ;
        List<AnalyseDetail> result = new ArrayList<>();
        for(AnalyseDetail analyseDetail :list){
            i++ ;
            result.add(analyseDetail);
            if(i % 100 == 0){
                analyseDetailMapper.insertBatch(result);
                result = new ArrayList<>();
            }
        }
        if(result.size() > 0){
            analyseDetailMapper.insertBatch(result);
        }
        return  1 ;
    }

    @Override
    public List<AnalyseDetail> selectByAnalyseId(int analyseId) {
        return analyseDetailMapper.selectByAnalyseId(analyseId);
    }

    @Override
    public Double selectDifficult(int analyseId, int difficult) {
        AnalyseDetail analyseDetail = new AnalyseDetail();
        analyseDetail.setDifficult(difficult);
        analyseDetail.setAnalyseId(analyseId);
        return analyseDetailMapper.selectDifficult(analyseDetail);
    }

    @Override
    public Double selectSumType(int analyseId, String questionType) {
        AnalyseDetail analyseDetail = new AnalyseDetail();
        analyseDetail.setQuestionType(questionType);
        analyseDetail.setAnalyseId(analyseId);
        return analyseDetailMapper.selectSumType(analyseDetail);
    }

    @Override
    public List<AnalyseDetail> selectDifficultDetail(int analyseId, int difficult) {
        AnalyseDetail analyseDetail = new AnalyseDetail();
        analyseDetail.setDifficult(difficult);
        analyseDetail.setAnalyseId(analyseId);
        return analyseDetailMapper.selectDifficultDetail(analyseDetail);
    }

    @Override
    public List<String> selectQuestionType(int analyseId) {
        return analyseDetailMapper.selectQuestionType(analyseId);
    }

    @Override
    public List<String> selectQuestionNumberByType(int analyseId, String questionType) {
        AnalyseDetail analyseDetail = new AnalyseDetail();
        analyseDetail.setQuestionType(questionType);
        analyseDetail.setAnalyseId(analyseId);
        return analyseDetailMapper.selectQuestionNumberByType(analyseDetail);
    }

    @Override
    public List<String> selectQuestionNumberByDifficult(int analyseId, int difficult) {
        AnalyseDetail analyseDetail = new AnalyseDetail();
        analyseDetail.setDifficult(difficult);
        analyseDetail.setAnalyseId(analyseId);
        return analyseDetailMapper.selectQuestionNumberByDifficult(analyseDetail);
    }
}
