package com.jevon.service.impl;

import com.jevon.mapper.ClassCourseMapper;
import com.jevon.mapper.ClassModelMapper;
import com.jevon.model.ClassCourse;
import com.jevon.model.ClassModel;
import com.jevon.service.ClassCourseService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * @author chen
 * @version 1.0
 * @date 2019/9/24 0024 11:45
 */
@Service("classCourseService")
public class ClassCourseServiceImpl implements ClassCourseService {

    @Autowired
    ClassCourseMapper classCourseMapper ;

    @Autowired
    ClassModelMapper classModelMapper;

    @Override
    public int insertBatch(List<ClassCourse> classCourses) {
        int i = 0 ;
        List<ClassCourse> result = new ArrayList<>();
        for(ClassCourse classCourse :classCourses){
            i++ ;
            result.add(classCourse);
            if(i % 100 == 0){
                classCourseMapper.insertBatch(result);
                result = new ArrayList<>();
            }
        }
        if(result.size()>0){
            classCourseMapper.insertBatch(result);
        }
        return 1;
    }

    @Override
    public boolean insertSchoolClass(List<ClassCourse> classCourses) {
        List<ClassModel> classModels = classModelMapper.selectBySchoolId(classCourses.get(0).getSchoolId());
        Date date = new Date();
        for(ClassModel classModel : classModels){
            for(ClassCourse classCourse : classCourses){
                classCourse.setGrade(classModel.getGrade());
                classCourse.setClassId(classModel.getClassId());
                classCourse.setCreateTime(date);
            }
            classCourseMapper.insertBatch(classCourses);
        }
        return true;
    }

    @Override
    public ClassCourse selectClassCourse(ClassCourse classCourse) {
        return classCourseMapper.selectClassCourse(classCourse);
    }

    @Override
    public int updateByPrimaryKey(ClassCourse record) {
        return classCourseMapper.updateByPrimaryKey(record);
    }

    @Override
    public boolean selectSingleOrDouble(ClassCourse classCourse) {
        return classCourseMapper.selectSingleOrDouble(classCourse) > 1 ;
    }

    @Override
    public int selectMaxCourseNumber(int schoolId , String team) {
        ClassCourse classCourse = new ClassCourse();
        classCourse.setSchoolId(schoolId);
        classCourse.setTeam(team);
        return classCourseMapper.selectMaxCourseNumber(classCourse);
    }

    @Override
    public List<ClassCourse> selectByClassIdAndSingleOrDouble(ClassCourse classCourse) {
        return classCourseMapper.selectByClassIdAndSingleOrDouble(classCourse);
    }

    @Override
    public int selectCourseByClassIdAndWeek(ClassCourse classCourse) {
        return classCourseMapper.selectCourseByClassIdAndWeek(classCourse).size();
    }

    @Override
    public int updatePublicOreElective(ClassCourse classCourse) {
        return classCourseMapper.updatePublicOreElective(classCourse);
    }

    @Override
    public List<ClassCourse> selectNoCourse(int classId , String team) {
        ClassCourse classCourse = new ClassCourse();
        classCourse.setClassId(classId);
        classCourse.setTeam(team);
        return classCourseMapper.selectNoCourse(classCourse);
    }

    @Override
    public List<ClassCourse> selectWeekCourse(int classId, int week, int singOrDouble, String courseName , String team) {
        ClassCourse classCourse = new ClassCourse();
        classCourse.setClassId(classId);
        classCourse.setWeek(week);
        classCourse.setSingleOrDouble(singOrDouble);
        classCourse.setCourseName(courseName);
        classCourse.setTeam(team);
        return classCourseMapper.selectWeekCourse(classCourse);
    }

    @Override
    public List<ClassCourse> selectClassCourseByClass(ClassCourse classCourse) {
        return classCourseMapper.selectClassCourseByClass(classCourse);
    }

    @Override
    public int deleteBySchoolIdAndTeam(int schoolId, String team) {
        ClassCourse classCourse = new ClassCourse();
        classCourse.setSchoolId(schoolId);
        classCourse.setTeam(team);
        return classCourseMapper.deleteBySchoolIdAndTeam(classCourse);
    }

    @Override
    public int recallClassCourse(ClassCourse classCourse) {
        return classCourseMapper.recallClassCourse(classCourse);
    }

    @Override
    public List<ClassCourse> copyClassCourse(int schoolId ,String team) {
        ClassCourse classCourse = new ClassCourse();
        classCourse.setSchoolId(schoolId);
        classCourse.setTeam(team);
        return classCourseMapper.copyClassCourse(classCourse);
    }
}
