package com.jevon.service.impl;

import com.jevon.mapper.ClassModelMapper;
import com.jevon.model.ClassModel;
import com.jevon.service.ClassModelService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @author chen
 * @version 1.0
 * @date 2019/9/25 0025 9:00
 */
@Service("classModelService")
public class ClassModelServiceImpl implements ClassModelService {

    @Autowired
    ClassModelMapper classModelMapper;

    @Override
    public ClassModel selectByPrimaryKey(Integer classId) {
        return classModelMapper.selectByPrimaryKey(classId);
    }

    @Override
    public int insertBatch(List<ClassModel> list) {
        return classModelMapper.insertBatch(list);
    }

    @Override
    public ClassModel selectBySchoolIdAndClassNameAndGrade(ClassModel classModel) {
        return classModelMapper.selectBySchoolIdAndClassNameAndGrade(classModel);
    }

    @Override
    public List<ClassModel> selectBySchoolIdAndGrade(int schoolId , String grade ) {
        ClassModel classModel = new ClassModel();
        classModel.setSchoolId(schoolId);
        classModel.setGrade(grade);
        return classModelMapper.selectBySchoolIdAndGrade(classModel);
    }

    @Override
    public List<ClassModel> selectBySchoolId(int schoolId) {
        return classModelMapper.selectBySchoolId(schoolId);
    }

    @Override
    public int deleteSchool(int schoolId) {
        return classModelMapper.deleteSchool(schoolId);
    }
}
