package com.jevon.service.impl;

import com.jevon.mapper.CourseMapper;
import com.jevon.model.Course;
import com.jevon.service.CourseService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @author chen
 * @version 1.0
 * @date 2019/10/9 0009 9:45
 */
@Service("courseService")
public class CourseServiceImpl implements CourseService {

    @Autowired
    CourseMapper courseMapper;

    @Override
    public int insertBatch(List<Course> list) {
        return courseMapper.insertBatch(list);
    }

    @Override
    public List<Course> selectBySchoolId(int schoolId) {
        return courseMapper.selectBySchoolId(schoolId);
    }

    @Override
    public List<Course> selectBySchoolId2(int schoolId) {
        return courseMapper.selectBySchoolId2(schoolId);
    }

    @Override
    public List<Course> selectByCourse(Course course) {
        return courseMapper.selectByCourse(course);
    }

    @Override
    public Course selectBySchoolIdAndCourseId(int schoolId, int courseId) {
        Course course = new Course();
        course.setSchoolId(schoolId);
        course.setCourseId(courseId);
        List<Course> list = courseMapper.selectByCourse(course) ;
        if(list != null && list.size() > 0){
            return list.get(0);
        }else {
            return null ;
        }
    }

    @Override
    public Course selectBySchoolIdAndCourseName(int schoolId, String courseName) {
        Course course = new Course();
        course.setSchoolId(schoolId);
        course.setCourseName(courseName);
        List<Course> list = courseMapper.selectByCourse(course) ;
        if(list != null && list.size() > 0){
            return list.get(0);
        }else {
            return null ;
        }
    }

    @Override
    public int updateCourseType(int courseId , int courseType , int schoolId) {
        Course course = new Course();
        course.setCourseId(courseId);
        course.setCourseType(courseType);
        course.setSchoolId(schoolId);
        return courseMapper.updateCourseType(course);
    }

    @Override
    public int deleteSchoolId(int schoolId) {
        return courseMapper.deleteSchoolId(schoolId);
    }

    @Override
    public int initSchoolId(int schoolId) {
        return courseMapper.initSchoolId(schoolId);
    }
}
