package com.jevon.service.impl;

import com.jevon.mapper.DimensionalMapper;
import com.jevon.model.Dimensional;
import com.jevon.service.DimensionalService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
 * @author chen
 * @version 1.0
 * @date 2019/10/18 0018 10:25
 */
@Service
public class DimensionalServiceImpl implements DimensionalService {

    @Autowired
    DimensionalMapper dimensionalMapper;

    @Override
    public int insert(Dimensional dimensional) {
        return dimensionalMapper.insert(dimensional);
    }

    @Override
    public List<Dimensional> select(Dimensional dimensional) {
        return dimensionalMapper.select(dimensional);
    }

    @Override
    public Dimensional selectByTypeAndName(int type, String name) {
        Dimensional dimensional = new Dimensional();
        dimensional.setDimensionalType(type);
        dimensional.setDimensionalName(name);
        List<Dimensional> list = dimensionalMapper.select(dimensional);
        if(list != null &&list.size() > 0){
            return list.get(0);
        }
        return null;
    }

    @Override
    public List<Dimensional> selectByAnalyse(int analyseId, int dimensionalType) {
        Dimensional dimensional = new Dimensional();
        dimensional.setDimensionalType(dimensionalType);
        dimensional.setAnalyseId(analyseId);
        return dimensionalMapper.selectByAnalyse(dimensional);
    }
}
