package com.jevon.service.impl;

import com.jevon.mapper.JoinClassMapper;
import com.jevon.model.JoinClass;
import com.jevon.service.JoinClassService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @author chen
 * @version 1.0
 * @date 2019/10/10 0010 8:35
 */
@Service("joinClassService")
public class JoinCLassServiceImpl implements JoinClassService {

    @Autowired
    JoinClassMapper joinClassMapper;

    @Override
    public int insertBatch(List<JoinClass> list) {
        Integer maxGroup = joinClassMapper.selectMaxGroup();
        if(maxGroup == null){
            maxGroup = 1 ;
        }else {
            maxGroup = maxGroup + 1 ;
        }
        for(JoinClass joinClass : list){
            joinClass.setCourseGroup(maxGroup);
        }
        return joinClassMapper.insertBatch(list);
    }

    @Override
    public List<JoinClass> selectByCourse(JoinClass joinClass) {
        return joinClassMapper.selectByCourse(joinClass);
    }

    @Override
    public List<JoinClass> selectByCourseGroup(int courseGroup) {
        return joinClassMapper.selectByCourseGroup(courseGroup);
    }

    @Override
    public int deleteBySchoolIdAndTeam(int schoolId, String team) {
        JoinClass joinClass = new JoinClass();
        joinClass.setTeam(team);
        joinClass.setSchoolId(schoolId);
        return joinClassMapper.deleteBySchoolIdAndTeam(joinClass);
    }

    @Override
    public int deleteCourseGroup(int courseGroup) {
        return joinClassMapper.deleteCourseGroup(courseGroup);
    }
}
