package com.jevon.service.impl;

import com.jevon.mapper.LeagueMapper;
import com.jevon.model.League;
import com.jevon.service.LeagueService;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
 * @author chen
 * @version 1.0
 * @date 2019/10/22 0022 9:09
 */
@Service
public class LeagueServiceImpl implements LeagueService {

    @Autowired
    LeagueMapper leagueMapper;

    @Override
    public int insert(League league) {
        return leagueMapper.insert(league);
    }

    @Override
    public int insertBatch(List<League> list) {
        return leagueMapper.insertBatch(list);
    }

    @Override
    public int update(int id, String league) {
        League update = new League();
        update.setId(id);
        update.setLeague(league);
        return leagueMapper.update(update);
    }

    @Override
    public int initLeagueSchool(int id, String schoolName) {
        League result = leagueMapper.selectById(id) ;
        League search = new League();
        search.setAnalyseId(result.getAnalyseId());
        search.setSchoolName(schoolName);
        List<League> leagues = leagueMapper.selectByLeague(search) ;
        if(leagues != null & leagues.size() >0){
            return 0 ;
        }else {
            search.setLeague(result.getLeague());
            search.setSchoolName(null);
            List<League> list = leagueMapper.selectByLeague(search);
            boolean isCreate = true ;
            for(League temp : list){
                if(StringUtils.isBlank(temp.getSchoolName())){
                    temp.setSchoolName(schoolName);
                    leagueMapper.update(temp);
                    isCreate = false;
                    break;
                }
            }
            if(isCreate){
                League createLeague = new League();
                createLeague.setAnalyseId(result.getAnalyseId());
                createLeague.setLeague(result.getLeague());
                createLeague.setSchoolName(schoolName);
                leagueMapper.insert(createLeague);
            }
            return 1;
        }
    }

    @Override
    public List<League> selectByAnalyseId(int analyseId) {
        League league = new League();
        league.setAnalyseId(analyseId);
        return leagueMapper.selectByLeague(league);
    }


    @Override
    public List<String> getLeagueBySchoolName(int analyseId, String schoolName) {
        League league = new League();
        league.setAnalyseId(analyseId);
        league.setSchoolName(schoolName);
        List<League> leagues = leagueMapper.selectByLeague(league);
        if(leagues != null && leagues.size() > 0){
            League search = new League();
            search.setAnalyseId(analyseId);
            search.setLeague(leagues.get(0).getLeague());
            List<League> result = leagueMapper.selectByLeague(search);
            List<String> leagueSchoolName = new ArrayList<>();
            for(League league1 : result){
                leagueSchoolName.add(league1.getSchoolName());
            }
            return leagueSchoolName ;
        }
        return null;
    }
}
