package com.jevon.service.impl;

import com.jevon.mapper.ScheduleMapper;
import com.jevon.model.Schedule;
import com.jevon.service.ScheduleService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;

/**
 * @author chen
 * @version 1.0
 * @date 2019/10/10 0010 11:26
 */
@Service("scheduleService")
public class ScheduleServiceImpl implements ScheduleService {

    @Autowired
    ScheduleMapper scheduleMapper;

    @Override
    public int insert(Schedule schedule) {
        schedule.setCreateTime(new Date());
        schedule.setSpeed(0);
        return scheduleMapper.insert(schedule);
    }

    @Override
    public List<Schedule> selectBySchool(int schoolId) {
        return scheduleMapper.selectBySchool(schoolId);
    }

    @Override
    public int updateSpeed(Schedule schedule) {
        return scheduleMapper.updateSpeed(schedule);
    }

    @Override
    public Schedule selectById(int id) {
        return scheduleMapper.selectById(id);
    }

    @Override
    public Schedule selectBySchoolAndTeam(Schedule schedule) {
        return scheduleMapper.selectBySchoolAndTeam(schedule);
    }

    @Override
    public int deleteBySchedule(int id) {
        return scheduleMapper.deleteBySchedule(id);
    }

    @Override
    public int updateZuoxi(Schedule schedule) {
        return scheduleMapper.updateZuoxi(schedule);
    }

    @Override
    public int update(Schedule schedule) {
        return scheduleMapper.update(schedule);
    }
}
