package com.jevon.service.impl;

import com.jevon.mapper.StudentDetailMapper;
import com.jevon.model.StudentDetail;
import com.jevon.service.StudentDetailService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
 * @author chen
 * @version 1.0
 * @date 2019/10/18 0018 13:47
 */
@Service
public class StudentDetailServiceImpl implements StudentDetailService {

    @Autowired
    StudentDetailMapper studentDetailMapper;

    @Override
    public int insertBatch(List<StudentDetail> list) {
        int i = 0 ;
        List<StudentDetail> result = new ArrayList<>();
        for(StudentDetail studentDetail :list){
            i++ ;
            result.add(studentDetail);
            if(i % 100 == 0){
                studentDetailMapper.insertBatch(result);
                result = new ArrayList<>();
            }
        }
        if(result.size()>0){
            studentDetailMapper.insertBatch(result);
        }
        return  1 ;
    }

    @Override
    public Double selectSumScore(int analyseId, List<String> league , String schoolName, String examNumber) {
        StudentDetail studentDetail = new StudentDetail();
        studentDetail.setAnalyseId(analyseId);
        studentDetail.setSchoolName(schoolName);
        studentDetail.setExamNumber(examNumber);
        studentDetail.setSchoolNames(league);
        return studentDetailMapper.selectSumScore(studentDetail);
    }


    @Override
    public Double selectSumScore(int analyseId, List<String> league, String schoolName, List<String> examNumbers) {
        StudentDetail studentDetail = new StudentDetail();
        studentDetail.setAnalyseId(analyseId);
        studentDetail.setSchoolName(schoolName);
        studentDetail.setExamNumbers(examNumbers);
        studentDetail.setSchoolNames(league);
        return studentDetailMapper.selectSumScore(studentDetail);
    }

    @Override
    public Double selectStudentSumScore(int analyseId, String schoolName, String studentNumber, List<String> examNumbers) {
        StudentDetail studentDetail = new StudentDetail();
        studentDetail.setAnalyseId(analyseId);
        studentDetail.setSchoolName(schoolName);
        studentDetail.setExamNumbers(examNumbers);
        studentDetail.setStudentNumber(studentNumber);
        return studentDetailMapper.selectSumScore(studentDetail);
    }

    @Override
    public Double selectClassSumScore(int analyseId, String schoolName, String className, List<String> examNumbers) {
        StudentDetail studentDetail = new StudentDetail();
        studentDetail.setAnalyseId(analyseId);
        studentDetail.setSchoolName(schoolName);
        studentDetail.setExamNumbers(examNumbers);
        studentDetail.setClassName(className);
        return studentDetailMapper.selectSumScore(studentDetail);
    }

    @Override
    public int selectTrueByExamNumber(int analyseId, String schoolName, String examNumber) {
        StudentDetail studentDetail = new StudentDetail();
        studentDetail.setAnalyseId(analyseId);
        studentDetail.setSchoolName(schoolName);
        studentDetail.setExamNumber(examNumber);
        return studentDetailMapper.selectTrueByExamNumber(studentDetail);
    }

    @Override
    public int selectTrueByExamNumber(int analyseId,List<String> league , String schoolName, String examNumber, List<String> studentNumbers) {
        StudentDetail studentDetail = new StudentDetail();
        studentDetail.setAnalyseId(analyseId);
        studentDetail.setSchoolName(schoolName);
        studentDetail.setExamNumber(examNumber);
        studentDetail.setStudentNumbers(studentNumbers);
        studentDetail.setSchoolNames(league);
        return studentDetailMapper.selectTrueByExamNumber(studentDetail);
    }

    @Override
    public int selectTrueByExamNumber(int analyseId, List<String> league, String schoolName, List<String> examNumbers, List<String> studentNumbers) {
        StudentDetail studentDetail = new StudentDetail();
        studentDetail.setAnalyseId(analyseId);
        studentDetail.setSchoolName(schoolName);
        studentDetail.setExamNumbers(examNumbers);
        studentDetail.setStudentNumbers(studentNumbers);
        studentDetail.setSchoolNames(league);
        return studentDetailMapper.selectTrueByExamNumber(studentDetail);
    }
}
