package com.jevon.service.impl;

import com.jevon.mapper.TeacherClassMapper;
import com.jevon.model.TeacherClass;
import com.jevon.service.TeacherClassService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
 * @author chen
 * @version 1.0
 * @date 2019/9/29 0029 11:31
 */
@Service("teacherClassService")
public class TeacherClassServiceImpl implements TeacherClassService {

    @Autowired
    TeacherClassMapper teacherClassMapper;

    @Override
    public int insert(TeacherClass teacherClass) {
        return teacherClassMapper.insert(teacherClass);
    }

    @Override
    public int insertBatch(List<TeacherClass> teacherClasses) {
        int i = 0 ;
        List<TeacherClass> result = new ArrayList<>();
        for(TeacherClass teacherClass :teacherClasses){
            i++ ;
            result.add(teacherClass);
            if(i % 100 == 0){
                teacherClassMapper.insertBatch(result);
                result = new ArrayList<>();
            }
        }
        if(result.size()>0){
            teacherClassMapper.insertBatch(result);
        }
        return 1;
    }

    @Override
    public List<TeacherClass> selectByCourseName(TeacherClass teacherClass) {
        TeacherClass search = new TeacherClass();
        search.setTeam(teacherClass.getTeam());
        search.setSchoolId(teacherClass.getSchoolId());
        search.setCourseName(teacherClass.getCourseName());
        return teacherClassMapper.selectByTeacherClass(search);
    }

    @Override
    public TeacherClass selectByTeacher(TeacherClass teacherClass) {
        TeacherClass search = new TeacherClass();
        search.setTeam(teacherClass.getTeam());
        search.setSchoolId(teacherClass.getSchoolId());
        search.setCourseName(teacherClass.getCourseName());
        search.setTeacherName(teacherClass.getTeacherName());
        search.setClassId(teacherClass.getClassId());
        return teacherClassMapper.selectByTeacherClass(search).get(0);
    }

    @Override
    public TeacherClass selectByCourseAndClass(TeacherClass teacherClass) {
        TeacherClass search = new TeacherClass();
        search.setTeam(teacherClass.getTeam());
        search.setSchoolId(teacherClass.getSchoolId());
        search.setCourseName(teacherClass.getCourseName());
        search.setGrade(teacherClass.getGrade());
        search.setClassId(teacherClass.getClassId());
        return teacherClassMapper.selectByTeacherClass(search).get(0);
    }

    @Override
    public List<TeacherClass> selectBySchoolAndTeam(TeacherClass teacherClass) {
        TeacherClass search = new TeacherClass();
        search.setTeam(teacherClass.getTeam());
        search.setSchoolId(teacherClass.getSchoolId());
        return teacherClassMapper.selectByTeacherClass(search);
    }

    @Override
    public int deleteBySchoolAndTeam(TeacherClass teacherClass) {
        return teacherClassMapper.deleteBySchoolAndTeam(teacherClass);
    }

    @Override
    public TeacherClass selectById(int tClassId) {
        TeacherClass search = new TeacherClass();
        search.settClassId(tClassId);
        return teacherClassMapper.selectByTeacherClass(search).get(0);
    }

    @Override
    public int updateSchedule(int tClassId) {
        return teacherClassMapper.updateSchedule(tClassId);
    }

    @Override
    public int selectHasSchedule(int schoolId, String team) {
        TeacherClass teacherClass = new TeacherClass();
        teacherClass.setSchoolId(schoolId);
        teacherClass.setTeam(team);
        return teacherClassMapper.selectHasSchedule(teacherClass);
    }

    @Override
    public int recallTeacherClass(int tClassId) {
        return teacherClassMapper.recallTeacherClass(tClassId);
    }

    @Override
    public int selectTeacherDayClass(int schoolId, String team, String teacherName) {
        TeacherClass search = new TeacherClass() ;
        search.setSchoolId(schoolId);
        search.setTeam(team);
        search.setTeacherName(teacherName);
        List<TeacherClass> list = teacherClassMapper.selectByTeacherClass(search);
        int sumClassNumber = 0 ;
        for(TeacherClass teacherClass :list){
            sumClassNumber += teacherClass.getTimes();
        }
        return (sumClassNumber/5) +1;
    }
}
